<template>
  <div id="class_board_wrapper" class="bt-container">
    <el-breadcrumb style="font-size: 24px; margin-top: 16px; margin-bottom: 32px;" separator=">">
      <el-breadcrumb-item v-if="currentTeachingClass(classId) !== undefined" :to="{ path: '/a/teacher/NNclass/'+classId }">{{ currentTeachingClass(classId).name }}</el-breadcrumb-item>
      <el-breadcrumb-item v-if="currentStudyingClass(classId) !== undefined" :to="{ path: '/a/teacher/NNclass/'+classId }">{{ currentStudyingClass(classId).name }}</el-breadcrumb-item>
      <el-breadcrumb-item v-if="currentPreviewClass(classId) !== undefined" :to="{ path: '/a/teacher/NNclass/'+classId }">{{ currentPreviewClass(classId).name }}</el-breadcrumb-item>
      <el-breadcrumb-item>{{ $t('CLASS_MENU.BOARD') }}</el-breadcrumb-item>
      <div style="text-align: right;">
        <a href="javascript:history.back();">
          <el-button size="small">{{ $t('ITEM_FROM_BANK.BACK') }}</el-button>
        </a>
      </div>
    </el-breadcrumb>
    <el-table :data="postList" @cell-click="onDetail" style="width: 100%">
      <el-table-column prop="board_id" :label="$t('LECTURE_LIST.NUMBER')" width="130">
      </el-table-column>
      <el-table-column prop="name" :label="$t('BOARD.TITLE')">
      </el-table-column>
      <el-table-column prop="user.name" :label="$t('BOARD.CREATOR')" width="180">
      </el-table-column>
      <el-table-column prop="created_at" :label="$t('BOARD.REG_DATE')" width="230">
      </el-table-column>
      <el-table-column prop="num_views" :label="$t('BOARD.VIEWS')" width="180">
      </el-table-column>
    </el-table>
    <div class="liner">
      <div style="display: inline; position:relative;">
        <el-button size="small" @click="onClick('NAVBACK')">&lt;&lt;</el-button>
        <el-button size="small" :key="navNum" v-for="navNum in navNumList" plain @click="onClick('CHANGEPAGE',navNum)">{{ navNum }}</el-button>
        <el-button size="small" @click="onClick('NAVNEXT')">&gt;&gt;</el-button>
      </div>
      <el-button size="small" style="float:right;" @click="onClick('WRITE')" plain>{{ $t('BOARD.POST') }}</el-button>
    </div>
    <div style="display: inline; position:relative;">
      <el-select v-model="searchType" size="small" style="display: inline-block; width: 100px;">
        <el-option
          v-for="option in selectOptionList"
          :key="option.value"
          :label="option.label"
          :value="option.value">
        </el-option>
      </el-select>
      <div style="display: inline-block; width: 200px;">
        <el-input :placeholder="$t('STUDENT_MENU.ENT_SEARCH_TERM')" v-model="searchWord" @keyup.enter="onClick('SEARCH')"></el-input>
      </div>
      <el-button @click="onClick('SEARCH')" icon="el-icon-search" circle></el-button>
    </div>
  </div>
</template>

<script>
import { mapState, mapGetters, mapActions } from 'vuex';

export default {
  async created() {
    const vm = this;
    vm.$data.postTotalCount = await vm.getPostTotalCount({
      classId: vm.$route.params.classId,
      type: this.$route.query.type !== undefined ? this.$route.query.type : '',
      query: this.$route.query.query !== undefined ? this.$route.query.query : '',
    });
    vm.updateNavNumList(1);
    await vm.getPostList({
      classId: vm.$route.params.classId,
      pageNum: vm.$route.params.pageNum,
      type: this.$route.query.type !== undefined ? this.$route.query.type : '',
      query: this.$route.query.query !== undefined ? this.$route.query.query : '',
    });
  },
  computed: {
    ...mapState('board', [
      'postList',
    ]),
    ...mapGetters('NNclass', [
      'currentTeachingClass',
      'currentStudyingClass',
      'currentPreviewClass',
    ]),
    classId() {
      const vm = this;
      return Number.parseInt(vm.$route.params.classId, 10);
    },
  },
  methods: {
    ...mapActions('board', [
      'getPostList',
      'getPostTotalCount',
    ]),
    updateNavNumList(navStartNum) { // 게시판 하단 네비게이터를 업데이트 함
      const temp = this.$data.postTotalCount - (((navStartNum - 1) * 10) + 1);
      let naviAmount = (Math.floor(temp / 10) + 1);
      if (naviAmount > 10) {
        naviAmount = 10;
      }
      this.$data.navNumList = [];
      for (let i = 0; i < naviAmount; i += 1) {
        this.$data.navNumList.push(navStartNum + i);
      }
    },
    onDetail(row) {
      this.$router.push(`/a/class/${this.$route.params.classId}/NNboarddetail/${row.board_id}`);
    },
    onClick(type, arg) {
      const vm = this;
      switch (type) {
        case 'SEARCH': {
          vm.$router.push({ path: `/a/class/${vm.$route.params.classId}/board/${vm.$route.params.pageNum}`, query: { type: `${vm.$data.searchType}`, query: `${vm.$data.searchWord}` } });
          break;
        }
        case 'WRITE': {
          vm.$router.push(`/a/class/${vm.$route.params.classId}/boardwrite`);
          break;
        }
        case 'CHANGEPAGE': {
          vm.getPostList({
            classId: vm.$route.params.classId,
            pageNum: arg - 1,
          });
          break;
        }
        case 'NAVBACK': {
          if (vm.$data.navStartNum <= 1) {
            vm.$notify({
              title: vm.$t('NOTIFY.TITLE'),
              message: vm.$t('NOTIFY.NO_PREV_LIST'),
              type: 'error',
              duration: 0,
            });
          } else {
            vm.$data.navStartNum -= 10;
            vm.updateNavNumList(vm.$data.navStartNum);
          }
          break;
        }
        case 'NAVNEXT': {
          if (vm.$data.postTotalCount < ((vm.$data.navStartNum + 9) * 10) + 1) {
            vm.$notify({
              title: vm.$t('NOTIFY.TITLE'),
              message: vm.$t('NOTIFY.NO_NEXT_LIST'),
              type: 'error',
              duration: 0,
            });
          } else {
            vm.$data.navStartNum += 10;
            vm.updateNavNumList(vm.$data.navStartNum);
          }
          break;
        }
        default: {
          throw new Error(`not defined type ${type}`);
        }
      }
    },
  },
  data() {
    return {
      searchType: 'name',
      searchWord: '',
      postTotalCount: 0,
      navStartNum: 1,
      navNumList: [],
      selectOptionList: [{
        value: 'name',
        label: this.$t('BOARD.TITLE'),
      }, {
        value: 'user',
        label: this.$t('BOARD.CREATOR'),
      }],
    };
  },
};
</script>